#include "calcul.h"

int Calcul::read_int(int first){
  string num;
  while(first >= '0' && first <= '9') {
    num.push_back(first);
    first = cin.get();
  }
  cin.putback(first);
  return stoi(num);
}

int Calcul::pop_arg(){
  if(pile.empty()){
    cerr << "Argument manquant." << endl;
    exit(1);
  }
  int val = pile.top();
  pile.pop();
  return val;
}

// modification 2: rajouter la valeur de x en paramètre
int Calcul::calcule(int valeur_x){
  int c = cin.get();
  int gauche,droite;
  while ( c !='\n' ){
    switch(c) {
      case '+' : 
	droite = pop_arg();
	gauche = pop_arg();
	pile.push(gauche+droite);
	break;
      case '-':
	droite = pop_arg();
	gauche = pop_arg();
	pile.push(gauche-droite);
	break;
      case '*':
	droite = pop_arg();
	gauche = pop_arg();
	pile.push(gauche*droite);
	break;
      // modification 1: rajouter la division
      case '/':
	droite = pop_arg();
	gauche = pop_arg();
	pile.push(gauche/droite);
	break;
      // fin modification 1
      // modification 2: cas où on lit x
      case 'x':
	pile.push(valeur_x);
	break;
      // fin modification 2
      case ' ' : break;
      default: 
	 if (c >= '0' && c <= '9') {
	   pile.push(read_int(c)); break;
	 } else {
	   cerr << "Caractère «" << (char) c << "» non reconnu." << endl;
	   exit(1);
	 }
    }
    c = cin.get();
  }
  if (pile.size() > 1) {
    cerr << "Trop d'arguments." << endl;
    exit(1);
  }
  if (pile.empty()) {
    cerr << "Pas d'entrée." << endl;
    exit(1);
  }
  return pile.top();
}


