#include "calcul.h"

int Calcul::read_int(int first){
  string num;
  while(first >= '0' && first <= '9') {
    num.push_back(first);
    first = cin.get();
  }
  cin.putback(first);
  return stoi(num);
}

int Calcul::pop_arg(){
  if(pile.empty()){
    cerr << "Argument manquant." << endl;
    exit(1);
  }
  int val = pile.top();
  pile.pop();
  return val;
}

// modification 3: nouvelle fonction pour récupérer le contenu 
// de la nouvelle pile
string Calcul::pop_arg_str(){
  if(pile_str.empty()){
    cerr << "Argument manquant" << endl;
    exit(1);
  }
  string val = pile_str.top();
  pile_str.pop();
  return val;
}

// modification 2: rajouter la valeur de x en paramètre
// modification 3: type de retour changé à string
string Calcul::calcule(int valeur_x){
  int c = cin.get();
  int gauche,droite;
  // modification 3: chaînes de caractère additionnelles
  string gauche_str,droite_str,exp_txt;
  while ( c !='\n' ){
    switch(c) {
      case '+' : 
	droite = pop_arg();
	gauche = pop_arg();
	pile.push(gauche+droite);
	// modification 3
	exp_txt = "(";
	droite_str = pop_arg_str();
	gauche_str = pop_arg_str();
        exp_txt += gauche_str + " + ";
	exp_txt += droite_str + ")";
	pile_str.push(exp_txt);
	// fin modification 3
	break;
      case '-':
	droite = pop_arg();
	gauche = pop_arg();
	pile.push(gauche-droite);
	// modification 3
	exp_txt = "(";
	droite_str = pop_arg_str();
	gauche_str = pop_arg_str();
        exp_txt += gauche_str + " - ";
	exp_txt += droite_str + ")";
	pile_str.push(exp_txt);
	// fin modification 3
	break;
      case '*':
	droite = pop_arg();
	gauche = pop_arg();
	pile.push(gauche*droite);
	// modification 3
	exp_txt = "(";
	droite_str = pop_arg_str();
	gauche_str = pop_arg_str();
        exp_txt += gauche_str + " * ";
	exp_txt += droite_str + ")";
	pile_str.push(exp_txt);
	// fin modification 3
	break;
      // modification 1: rajouter la division
      case '/':
	droite = pop_arg();
	gauche = pop_arg();
	pile.push(gauche/droite);
	// modification 3
	exp_txt = "(";
	droite_str = pop_arg_str();
	gauche_str = pop_arg_str();
        exp_txt += gauche_str + " / ";
	exp_txt += droite_str + ")";
	pile_str.push(exp_txt);
	// fin modification 3
	break;
      // fin modification 1
      // modification 2: cas où on lit x
      case 'x':
	pile.push(valeur_x);
	// modification 3
	pile_str.push(string("x"));
	// fin modification 3
	break;
      // fin modification 2
      case ' ' : break;
      default: 
	 if (c >= '0' && c <= '9') {
	   // modification 3
	   int num = read_int(c);
	   pile.push(num); 
	   pile_str.push(to_string(num));
	   // fin modification 3
	   break;
	 } else {
	   cerr << "Caractère «" << (char) c << "» non reconnu." << endl;
	   exit(1);
	 }
    }
    c = cin.get();
  }
  if (pile.size() > 1) {
    cerr << "Trop d'arguments." << endl;
    exit(1);
  }
  if (pile.empty()) {
    cerr << "Pas d'entrée." << endl;
    exit(1);
  }
  // modification 3: on retourne la version textuelle = la version calculée
  return pile_str.top() + string(" = ") + to_string(pile.top());
}


